package com.persagy.utils;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @description: 校验通用类
 * @author: lixing
 * @company: Persagy Technology Co.,Ltd
 * @since: 2021/2/1 2:40 下午
 * @version: V1.0
 **/
public class ValidateUtils {
    private static final String dateTimeDefaultPattern = "yyyyMMddHHmmss";

    /**
     * @description: 校验时间字符串是否合法
     * @param: dateTime 时间字符串
     * @param: pattern 时间格式
     * @return: boolean
     * @exception:
     * @author: lixing
     * @company: Persagy Technology Co.,Ltd
     * @since: 2021/2/1 4:10 下午
     * @version: V1.0
     */
    public static boolean validateDateTime(String dateTime, String pattern) {
        try {
            DateTimeFormatter inFormat = DateTimeFormatter.ofPattern(pattern);
            LocalDateTime.parse(dateTime, inFormat);
            return true;
        } catch (Exception e) {
            return false;
        }
    }

    /**
     * @description: 校验时间字符串是否合法
     * @param: dateTime 时间字符串
     * @return: boolean
     * @exception:
     * @author: lixing
     * @company: Persagy Technology Co.,Ltd
     * @since: 2021/2/1 4:10 下午
     * @version: V1.0
     */
    public static boolean validateDateTime(String dateTime) {
        return validateDateTime(dateTime, dateTimeDefaultPattern);
    }

//    public static void main(String[] args) {
//        boolean b = validateDateTime("20120232112233");
//        System.out.println(b);
//    }
}
